{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v2"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"},"vrackServices.FeatureAvailability":{"type":"object","description":"Availability of a feature in a region, derived from its availability zones","properties":{"availabilityZones":{"type":"array","description":"Availability of the feature in each availability zone of the region","items":{"$ref":"#/components/schemas/vrackServices.FeatureAvailabilityZone"},"readOnly":true},"status":{"allOf":[{"$ref":"#/components/schemas/vrackServices.FeatureAvailabilityStatusEnum"}],"description":"AVAILABLE in every availability zone, in some, or in none","readOnly":true}}},"vrackServices.FeatureAvailabilityStatusEnum":{"type":"string","description":"Availability of a feature in a region","enum":["AVAILABLE","PARTIALLY_AVAILABLE","UNAVAILABLE"]},"vrackServices.FeatureAvailabilityZone":{"type":"object","description":"Availability of a feature in one availability zone","properties":{"name":{"type":"string","description":"Availability zone name","readOnly":true},"status":{"allOf":[{"$ref":"#/components/schemas/vrackServices.FeatureAvailabilityZoneStatusEnum"}],"description":"Availability of the feature in the availability zone","readOnly":true}}},"vrackServices.FeatureAvailabilityZoneStatusEnum":{"type":"string","description":"Availability of a feature in an availability zone","enum":["AVAILABLE","UNAVAILABLE"]},"vrackServices.Region":{"type":"object","description":"A vRack Services compatible localization","properties":{"name":{"type":"string","description":"Region name","readOnly":true}}},"vrackServices.RegionFeatureAvailability":{"type":"object","description":"Feature availability of a region","properties":{"features":{"type":"object","description":"Availability of each feature, keyed by feature: bgp, netboot and each compatible managed service type listed by /reference/compatibleManagedServiceType. New keys can be added at any time: ignore the keys you do not know. A feature missing from the map is not offered in the region: treat it as UNAVAILABLE.","additionalProperties":{"$ref":"#/components/schemas/vrackServices.FeatureAvailability"},"readOnly":true},"region":{"type":"string","description":"Region name","readOnly":true}}}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/vrackServices/reference/compatibleManagedServiceType":{"get":{"operationId":"getVrackServicesCompatibleManagedServiceTypes","summary":"List compatible service types","description":"Returns the types of managed services that can get a Service Endpoint, as IAM resource types.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}},"examples":{"Example":{"value":["storageNetApp","anotherManagedService"],"summary":"Example"}}}}}},"tags":["Reference"],"x-developer-hub-navigation":[["Network","vRack Services","References@@@20"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/vrackServices/reference/compatibleManagedServiceType\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/vrackServices/reference/compatibleManagedServiceType\");\n\nprint_r($result);\n?>"}]}},"/vrackServices/reference/featureAvailability":{"get":{"operationId":"getVrackServicesFeatureAvailability","summary":"List feature availability","description":"Returns, per region, the availability of each feature: bgp, netboot and each compatible managed service type, overall and in each availability zone. A feature missing from a region is not offered there.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}},{"in":"query","name":"region","description":"Restrict the list to this region","schema":{"type":"string"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/vrackServices.RegionFeatureAvailability"}},"examples":{"Example":{"value":[{"features":{"bgp":{"availabilityZones":[{"name":"eu-west-gra-a","status":"AVAILABLE"}],"status":"AVAILABLE"},"nasHA":{"availabilityZones":[{"name":"eu-west-gra-a","status":"AVAILABLE"}],"status":"AVAILABLE"},"netboot":{"availabilityZones":[{"name":"eu-west-gra-a","status":"AVAILABLE"}],"status":"AVAILABLE"},"storageNetApp":{"availabilityZones":[{"name":"eu-west-gra-a","status":"UNAVAILABLE"}],"status":"UNAVAILABLE"}},"region":"eu-west-gra"}],"summary":"Example"}}}}}},"tags":["Reference"],"x-developer-hub-navigation":[["Network","vRack Services","References@@@30"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/vrackServices/reference/featureAvailability\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/vrackServices/reference/featureAvailability\");\n\nprint_r($result);\n?>"}]}},"/vrackServices/reference/region":{"get":{"operationId":"getVrackServicesRegions","summary":"List regions","description":"Returns the regions where vRack Services is available.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"header","name":"X-Pagination-Cursor","description":"Pagination cursor","schema":{"type":"string"}},{"in":"header","name":"X-Pagination-Size","description":"Pagination size","schema":{"type":"integer"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/vrackServices.Region"}},"examples":{"Example":{"value":[{"name":"eu-west-rbx"},{"name":"eu-west-lim"},{"name":"eu-west-gra"}],"summary":"Example"}}}}}},"tags":["Reference"],"x-developer-hub-navigation":[["Network","vRack Services","References@@@10"]],"x-badges":[{"color":"green","label":"Stable production version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/v2/vrackServices/reference/region\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/v2/vrackServices/reference/region\");\n\nprint_r($result);\n?>"}]}}},"tags":[{"name":"Reference","x-tag-expanded":false,"description":"Missing description"}]}
